-----------------------------------
-- Setting up scope and libs
-----------------------------------

local AddonName = "iTrack"
iTrack = LibStub("AceAddon-3.0"):NewAddon(AddonName, "AceEvent-3.0");

-----------------------------
-- Setting up the feed
-----------------------------

local function Feed_OnClick(anchor, button)
	if( button == "RightButton" ) then
		ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, anchor, 0, 0);
	end
end

iTrack.Feed = LibStub("LibDataBroker-1.1"):NewDataObject(AddonName, {
	type = "data source",
	text = "",
	OnClick = Feed_OnClick,
});

----------------------
-- Initializing
----------------------

function iTrack:OnInitialize()
	self:RegisterEvent("MINIMAP_UPDATE_TRACKING", "Update");
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "Update");
end

------------------------------------------
-- Update
------------------------------------------

function iTrack:Update()
	local types = GetNumTrackingTypes();
	local tracking = 0;
	
	for i = 1, types do
		local name, icon, active = GetTrackingInfo(i);
		
		if( active ) then
			tracking = tracking + 1;
			
			if( tracking == 1 ) then
				self.Feed.text = name;
				self.Feed.icon = icon;
			end
		end
	end
	
	if( tracking == 0 ) then
		self.Feed.text = FACTION_INACTIVE;
		self.Feed.icon = "Interface\\Minimap\\Tracking\\None";
	else
		self.Feed.text = ("|cff00ff00%d|r %s"):format(tracking, self.Feed.text);
	end
end